LeetCode283 移动0

LeetCode283 移动0

在这篇博客中,我们将探讨如何通过不复制数组的情况下,在原地对数组进行操作,将所有零移动到数组的末尾。这个问题的描述如下:

问题描述: 给定一个数组 nums,编写一个函数将所有 0 移动到数组的末尾,同时保持非零元素的相对顺序。

解决方案

算法思路

我们可以使用双指针技巧来解决这个问题。具体来说,我们可以使用快速排序的思想,将数组中的非零元素按顺序移到数组的前面,而零元素会留在后面。

我们定义两个指针:一个指针 forst 用于指向已处理的非零元素的末尾位置,另一个指针 back 用于遍历数组。

代码实现

cpp 复制代码
#include <iostream>
#include <vector>

using namespace std;

class Solution {
public:
    void moveZeroes(vector<int>& nums) {
        int forst = -1; // 指向已处理的非零元素的末尾位置
        int back = 0;   // 遍历数组的指针

        while (back < nums.size()) {
            if (nums[back] != 0) {
                swap(nums[back], nums[++forst]); // 将非零元素移到数组的前面
            }
            back++;
        }
    }
};

时间复杂度分析

该算法只对数组进行了一次线性遍历,因此时间复杂度为 O(n),其中 n 是数组的长度。

结论

通过使用双指针技巧,我们成功设计了一个时间复杂度为 O(n) 的算法,将给定数组中的所有零元素移动到数组的末尾,同时保持非零元素的相对顺序。这种解决方案在不复制数组的情况下原地对数组进行操作,具有较好的性能。

相关推荐
一去不复返的通信er6 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人9 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade10 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
小郎君65812 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一12 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10012 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao13 小时前
算法56,重排链表
数据结构·算法·链表
qq_4523962313 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin
西索斯coding14 小时前
Qwen3-Max 与 Qwen-Plus:60 个真实修复任务评测方案
大数据·网络·算法·ai